### Test Scenario

Benchmarking Read Managed User API.


### Test Environment Details
1. No of AKS node - 16
2. No of learner service replicas - 8 (1 Core and 3 GB)
3. Cassandra Cluster- 7 Nodes; CPU- 8Core; Memory- 32GB
4. ES Cluster - 3 nodes; CPU- 16core ; Memory- 64GB
5. Release version - Release 4.8.0


**API End Point:** 
`/api/user/v2/read/${userId}?withTokens=true`


**Executing the test scenario using JMeter:**

```./run_scenario.sh <JMETER_HOME> <JMETER_IP_LIST> <SCENARIO_NAME> <SCENARIO_ID> <THREADS_COUNT> <RAMPUP_TIME> <CTRL_LOOPS> <API_KEY> <DOMAIN_FILE> <CSV_FILE>```

e.g.

```./run_scenario.sh /mount/data/benchmark/apache-jmeter-5.3/ 'Jmeter_Slave1_IP,Jmeter_Slave2_IP,Jmeter_Slave3_IP,Jmeter_Slave4_IP' read-child-user read-child-user_Id1 5 1 5 "ABCDEFabcdef012345" ~/sunbird-perf-tests/sunbird-platform/testdata/host.csv ~/sunbird-perf-tests/sunbird-platform/testdata/child-userId.csv```

**Note**
- authenticatedUserToken,authenticatedFor - 2 different tokens are required for this api.
- `authenticatedUserToken` in main user's access token , who has created the child users.
- `authenticatedFor`  is child user's authenticated token.
- Update `child-userId.csv` file with userIds, authenticatedUserToken and authenticatedFor data.
- Update `host.csv` file data with correct host details before running the test. It can be domain details / Kubernetes Node IPs/ LB IPs/ Direct Service IPs with port details.


### Test Result:

|API              |Thread Count|Samples |Errors%    |Throughput/sec|Avg Resp Time |95th pct |99th pct|
|-----------------|------------|--------|-----------| -------------|--------------|---------|--------|
|Read Managed User|200         |200000 |0(0.00%) | 133.3        | 1245           |  1492    |1904      |


### Server Utilisation:
| Backend          | CPU Usage %(max) | Memory Utilization (max) |
| ------------- | ------------- |------------- |
| Learner Service (CPU-1 Core; Memory- 3 GB)  |50% | 737 MiB |
| Cassandra (CPU- 16Core; Memory- 64GB)|3.66%    | 13.64 GB |
| ES (CPU- 16core ; Memory- 64GB)| 1.85%  | 28.51 GB |
